﻿using Infragistics.Web.UI.DisplayControls;
using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ProgressBarInsideCells
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack) {

                Session["DS"] = GetData();

            }
            this.WebHierarchicalDataGrid1.DataSource = (DataSet)Session["DS"];

             //for (int i = 0; i < this.WebHierarchicalDataGrid1.Rows.Count; i++) 
             //   {
             //   GridRecord row = this.WebHierarchicalDataGrid1.GridView.Rows[i];
             //   double value = (double)row.Items[3].Value;
             //   WebProgressBar webProgressBar = row.Items[5].FindControl("WebProgressBar1") as WebProgressBar;

             //   webProgressBar.Value = value;
             //   }
          
        }

        public DataSet GetData()
        {
            DataSet ds = new DataSet();

            string[] names = { "Peter", "Maria", "John", "Vladimir", "Gustavo" };

            DataTable ct = new DataTable("CustomersTable");
            var keys = new DataColumn[1];

            ct.Columns.Add("CustomerID", typeof(int));
            ct.Columns.Add("Name", typeof(string));
            ct.Columns.Add("Date", typeof(DateTime));
            ct.Columns.Add("TasksCompleted", typeof(double));
            ct.Columns.Add("TasksRequired", typeof(double));

            for (int i = 0; i < 5; i++)
            {
                var row = ct.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i];
                row[2] = DateTime.Now.AddDays(i * 2);
                row[3] = i * 10;
                row[4] = 100;
            }
            keys[0] = ct.Columns["CustomerID"];

            ct.PrimaryKey = keys;

            DataTable ordersTable = new DataTable("OrdersTable");
            var orderKeys = new DataColumn[2];

            ordersTable.Columns.Add("CustomerID", typeof(int));
            ordersTable.Columns.Add("OrderID", typeof(int));
            ordersTable.Columns.Add("Date", typeof(DateTime));


            foreach (DataRow customerRow in ct.Rows)
            {
                DataRow row = ordersTable.NewRow();

                for (int i = 0; i < 4; i++)
                {

                    row = ordersTable.NewRow();

                    row["CustomerId"] = customerRow["CustomerId"];
                    row["OrderID"] = i + 10 * Convert.ToInt32(customerRow["Customerid"]);
                    DateTime date = (DateTime)customerRow["Date"];
                    row["Date"] = date.AddDays(i * 3);
                    ordersTable.Rows.Add(row);
                }
            }


            ds.Tables.Add(ct);
            ds.Tables.Add(ordersTable);
            DataRelation relCustOrder = new DataRelation("CustOrder",
                ds.Tables["CustomersTable"].Columns["CustomerId"],
                ds.Tables["OrdersTable"].Columns["CustomerId"]);
            ds.Relations.Add(relCustOrder);

            return ds;

        }
       

        protected void WebHierarchicalDataGrid1_Init(object sender, EventArgs e)
        {

            //for (int i = 0; i < this.WebHierarchicalDataGrid1.Rows.Count; i++)
            //{
            //    GridRecord row = this.WebHierarchicalDataGrid1.GridView.Rows[i];
            //    double value = (double)row.Items[3].Value;
            //    WebProgressBar webProgressBar = row.Items[5].FindControl("WebProgressBar1") as WebProgressBar;

            //    webProgressBar.Value = value;
            //}
        }

        protected void WebHierarchicalDataGrid1_PreRender(object sender, EventArgs e)
        {
            for (int i = 0; i < this.WebHierarchicalDataGrid1.Rows.Count; i++)
            {
                GridRecord row = this.WebHierarchicalDataGrid1.GridView.Rows[i];
                double value = (double)row.Items[3].Value;
                double maximum = (double)row.Items[4].Value;
                WebProgressBar webProgressBar = row.Items[5].FindControl("WebProgressBar1") as WebProgressBar;

                webProgressBar.Value = value;
                webProgressBar.Maximum = maximum;
            }
        }
    }
}